package com.safran.morpho.matching;

import java.io.IOException;
import java.util.concurrent.ThreadPoolExecutor;

import javax.servlet.AsyncContext;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Matching two Jpegs.
 * @author DIN
 *
 */
@WebServlet(urlPatterns = "/matching", asyncSupported = true)
public class MatchingServlet extends HttpServlet {

    /**
     * Serial.
     */
    private static final long serialVersionUID = 1L;

 
    /**
     * {@inheritDoc}
     */
    @Override
    public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        treatment(request, response);
    } 

    /**
     * {@inheritDoc}
     */
    @Override
    public void doPost( HttpServletRequest request,  HttpServletResponse response) throws ServletException, IOException { 
        treatment(request, response);
    }
        
    /**
     * {@inheritDoc}
     */
    @Override
    public void service( HttpServletRequest request,  HttpServletResponse response) throws ServletException, IOException {
        treatment(request, response);
    }
  
    /**
     * Treatment matching.
     * @param request HttpServletRequest
     * @param response HttpServletResponse
     * @throws IOException if failed
     */
    private void treatment(final HttpServletRequest request,  final HttpServletResponse response) throws IOException {
        
        final AsyncContext asyncCtx = request.startAsync();
        asyncCtx.addListener(new AppAsyncListener());
        asyncCtx.setTimeout(9000);
 
        final ThreadPoolExecutor executor = (ThreadPoolExecutor) request.getServletContext().getAttribute("executor");
        executor.execute(new AsyncRequestProcessor(asyncCtx));
    }


 }
