//     All Rights Reserved © Copyright 2013 - Morpho - Paris France
//
//     This module is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
//
//     This program is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.

//     You should have received a copy of the GNU General Public License
//     along with this program.  If not, see <http://www.gnu.org/licenses/>.

function getCustomLayouts() {
    
    var myData = [
                    ['include_docs'         ,'false'                                        ],
 				    ['wildcard_character'   ,'%'                                            ],
				    ['sort_on'              ,'["auteur","ascending"],["titre","descending"]'],
				    ['select_list'          ,'["auteur","titre"]'                           ],
				    ['limit'                ,'[0,100]'                                      ],
				    ['conflicts'            ,'false'                                        ],
				    ['revs'                 ,'false'                                        ],
				    ['revs_info'            ,'false'                                        ],
				    ['max_retry'            ,'2'                                            ],
                    ['threshold'            ,'1'                                            ]
                ];
    
    return {
        // The default start page, also a simple example of a FitLayout.
        start: {
            id: 'start-panel',
            title: 'Start Page',
            layout: 'fit',
            bodyStyle: 'padding:25px',
            contentEl: 'start-div'  // pull existing content from the page
        },
        searching: {
            id: 'searching-panel',
            title: 'Searching Page',
            width: 1000,
            height: 600,
            layout: {
                type: 'table',
                columns: 2
            },
            defaults: {
                padding: '10 10 10 10',
            },
            items: [
                    {
                        xtype: 'textfield',
                        width: 410,
                        name: 'databaseS',
                        id: 'databaseS',
                        fieldLabel: 'Database',
                        value: 'jio',
                        labelWidth: 120,
                        msgTarget: 'side',
                        disabled: true,
                        allowBlank: false, // field required !!! ==> form.isValid()
                        anchor: '100%',
                        labelAlign: 'left',
                    },
                    {
                        title: "Actions",
                        frame: false,
                        border: false,
                        width: 400,
                        items:[
                               {
                                   xtype: 'button',
                                   text : 'Info Image',
                                   margin: '3px',
                                   listeners: {
                                       click: function() {
                                           var base = Ext.getCmp('databaseS').value;
                                           var id   = Ext.getCmp('idImage').value;
                                           if(null == base || base.length == 0 || null == id || id.length == 0){
                                               Ext.MessageBox.alert('Error', "Fields base or id image are missing.");
                                           } else {
                                               getDocument(id, base); 
                                           }
                                       }
                                   }
                               },
                               {
                                   xtype: 'button',
                                   text : 'Data Image',
                                   margin: '3px',
                                   listeners: {
                                       click: function() {
                                           var base = Ext.getCmp('databaseS').value;
                                           var id   = Ext.getCmp('idImage').value;
                                           if(null == base || base.length == 0 || null == id || id.length == 0){
                                               Ext.MessageBox.alert('Error', "Fields base or id image are missing.");
                                           } else {
                                               getAttachment(id, base); 
                                           }
                                       }
                                   }
                               },
                               {
                                   xtype: 'button',
                                   text : 'Images id list',
                                   margin: '3px',
                                   listeners: {
                                       click: function() {
                                           var base = Ext.getCmp('databaseS').value;
                                           var id   = Ext.getCmp('idImage').value;
                                           if(null == base || base.length == 0){
                                               Ext.MessageBox.alert('Error', "Fields base is missing.");
                                           } else {
                                        	   getAllDocs(id, base); 
                                           }
                                       }
                                   }
                               },
                               {
                                   xtype: 'button',
                                   text : 'Save',
                                   margin: '3px',
                                   listeners: {
                                       click: function() {
                                           var base = Ext.getCmp('databaseS').value;
                                           var id   = Ext.getCmp('idImage').value;
                                           if(null == base || base.length == 0 || null == id || id.length == 0){
                                               Ext.MessageBox.alert('Error', "Fields base or id image are missing.");
                                           } else {
                                               grouping(id, base); 
                                           }
                                       }
                                   }
                               },
                               {
                                   xtype: 'button',
                                   text : 'Clear logs',
                                   margin: '3px',
                                   listeners: {
                                       click: function() {
                                           clearData("msgS");
                                       }
                                   }
                               }
                              ]
                    },
                    {
                        xtype: 'textfield',
                        width: 410,
                        name: 'idImage',
                        id: 'idImage',
                        fieldLabel: 'ID searching',
                        labelWidth: 120,
                        msgTarget: 'side',
                        allowBlank: false, // field required !!! ==> form.isValid()
                        anchor: '100%',
                        labelAlign: 'left',
                        colspan: 2
                    },
                    {
                        title: 'Description',
                        frame: false,
                        border: false,
                        colspan: 2,
                        items: [
                                {
                                    x: 0,
                                    y: 81,
                                    hideLabel: true,
                                    xtype: 'textarea',
                                    name: 'msgS',
                                    id: 'msgS',
                                    width: '100%',
                                    height: 600
                                }
                               ]
                        
                    }     
                   ]
        },
        options: {
            id: 'options-panel',
            title: 'Options select Page',
            layout: 'fit',
            bodyPadding: 15,
            items: [
                        {
                            xtype: 'grid',
                            layout: 'fit',
                            store:  new Ext.data.ArrayStore({
                                                    // store configs
                                                    autoDestroy: true,
                                                    id: 'options_store',
                                                    // reader configs
                                                    fields: [
                                                             {name: 'Options' , type: 'String'   },
                                                             {name: 'Value'   ,  type: 'String'  }
                                                            ],
                                                    data: myData
                                                }),
                            columns: [
                                {
                                    text     : 'Name',
                                    width    : 200,
                                    sortable : false, 
                                    dataIndex: 'Options'
                                },
                                {
                                    text     : 'Value', 
                                    width    : 500, 
                                    sortable : false, 
                                    dataIndex: 'Value'
                                }
                            ],
                            stripeRows: true
                        } // end Grid
            
                    ]
        }
    };

}