package org.resilience.mark;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.resilience.RateToolException;
import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;



public class AuditParser {
	
	private final NodeList _issueList;
	
	public AuditParser(String filepath) throws RateToolException {
		File fXmlFile;
		try{
			fXmlFile = new File(filepath);
			DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder dBuilder = dbFactory.newDocumentBuilder();
			Document config=dBuilder.parse(fXmlFile);
			config.getDocumentElement().normalize();
			this._issueList=config.getElementsByTagName("Vulnerability");
		}catch(IOException e){
			throw new RateToolException("Failed at loading config: "+e.getMessage());
		}catch(ParserConfigurationException e){
			throw new RateToolException("Failed at loading config: "+e.getMessage());
		}catch(SAXException e){
			throw new RateToolException("Failed at loading config: "+e.getMessage());		
		}
	}
	
	public AuditParser(InputStream stream) throws RateToolException {

		try{
			DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder dBuilder = dbFactory.newDocumentBuilder();
			Document config=dBuilder.parse(stream);
			config.getDocumentElement().normalize();
			this._issueList=config.getElementsByTagName("Vulnerability");
			
		}catch(IOException e){
			throw new RateToolException("Failed at loading config: "+e.getMessage());
		}catch(ParserConfigurationException e){
			throw new RateToolException("Failed at loading config: "+e.getMessage());
		}catch(SAXException e){
			throw new RateToolException("Failed at loading config: "+e.getMessage());		
		}finally{
			try{
				if (stream!=null)
						stream.close();
			}catch(Exception ignore){}
		}
	}
	
	public NodeList getIssueList(){
		return this._issueList;
	}
	
	
	
}
