package org.resilience.mark;

import org.w3c.dom.Element;

public class Fortify_issue {
	private final Element _issue; 
	
	Fortify_issue(Element issue){
		this._issue = issue;
	}
	
	public String getCategoryName(){
		String name;
		if(this._issue.getElementsByTagName("Subtype").getLength() == 1) {
			name = this._issue.getElementsByTagName("Type").item(0).getTextContent().concat(": ").concat(this._issue.getElementsByTagName("Subtype").item(0).getTextContent());
		}else{
			name = this._issue.getElementsByTagName("Type").item(0).getTextContent();
		}
		return name;
	}
	
	public String getIssueID(){
		return this._issue.getElementsByTagName("InstanceID").item(0).getTextContent();
	}
	
	public String getDefaultSeverity(){
		return this._issue.getElementsByTagName("DefaultSeverity").item(0).getTextContent();
	}
	
	public String getFilepath(){
		return ((Element)(this._issue.getElementsByTagName("FunctionDeclarationSourceLocation").item(0))).getAttribute("path");
	}
	
	public String getLine(){
		return ((Element)(this._issue.getElementsByTagName("FunctionDeclarationSourceLocation").item(0))).getAttribute("line");
	}
	
	public boolean isSameIssueTo(Element issue){
		Fortify_issue test = new Fortify_issue(issue);
		return this.getIssueID().equals(test.getIssueID());
	}

}